#include <iostream>
#include <vector>
#include <fstream>
#include <string>

using namespace std;

#include "animal.h"
//#include "timer.h"

const int MAX = 50;
long int pole[MAX][MAX];
long int pole2[MAX][MAX];
//
int N,M,P;
int a,b,c,d;
//
int animals_jump = 0;

long int minor[MAX][MAX];
//
animal animals[200];
//
vector<long int> output;

ofstream fout;
ifstream fin;

void input()
{
    fin.open ("parash.in");
    fout.open ("parash.out");
    string temp; int temp_int;
    fin>>N>>M>>P;
    for(int i=0;i<N;i++)
    {
        for(int j=0;j<M;j++)
        {
            fin>>pole[i][j];
            pole2[i][j] = pole[i][j];
        }
    }
    for(int i=0;i<P;i++)
    {
        fin>>a>>b>>c>>d;
        animals[i].set(a,b,c,d);
        animals[i].number = i+1;
        getline(fin,temp);
        //
        for(int k=0;k<animals[i].r;k++)
        {
            getline(fin,temp);
            for(int j=0;j<animals[i].c;j++)
            {
                temp_int = (int)temp[j]-48;
                animals[i].mat[k][j]= temp_int*d;
            }
        }
    }
}

void sort_animals()
{
    animal a;
    for(int k=0;k<P/2;k++)
    {
        for(int i=0;i<P;i++)
        {
            for(int j=0;j<P;j++)
            {
                if (animals[i].k < animals[j].k && animals[i].t < animals[j].t)
                {
                    a = animals[j];
                    animals[j] = animals[i];
                    animals[i] = a;
                }
            }
        }
    }
}

void output_f()
{
    fout<<animals_jump<<endl;
    for(int i=0;i<output.size();i++)
    {
        if(i%3==0 && i!=0) fout<<endl;
        fout<< output[i] << " ";
    }
}

int main()
{
    input();
    //sort_animals();
    //
    int sum=0, o_sum =0 ;
    //
    for(int jivotno = 0 ; jivotno < P; jivotno++)
    {
        int j_r = animals[jivotno].r , j_c = animals[jivotno].c; bool animal_jumps = false;
        //
		for(int m1=0; m1<=(N-j_r) ; m1++)
        {
            for(int m2=0; m2<=(M-j_c) ; m2++)
            {
                sum=0;
                for(int k=m1; k < (m1+j_r) ; k++)
                {
                    for(int p=m2; p < (m2+j_c) ; p++)
                    {
                        if(animals[jivotno].mat[k-m1][p-m2] != 0 &&
                           pole[k][p] >= animals[jivotno].t )
                        {
                            sum+=pole[k][p];
                            animal_jumps = true;
                        }
                        else animal_jumps = false;
                    }
                }
                //
                if(sum>animals[jivotno].t && sum>animals[jivotno].sum && animal_jumps)
                {
                    animals[jivotno].sum = sum;
                    animals[jivotno].y = m1;
                    animals[jivotno].x = m2;
                }
            }
        }
        //
        if(animal_jumps)
        {
            //
            animals_jump++;
            output.push_back(animals[jivotno].number);
            output.push_back(animals[jivotno].y+1);
            output.push_back(animals[jivotno].x+1);
            //
            int o1 = animals[jivotno].y, o2 = animals[jivotno].x;
            //
            for(int k=o1; k<(o1+j_r);k++)
            {
                for(int p=o2; p < (o2+j_c);p++)
                {
                    if(animals[jivotno].mat[k-o1][p-o2] != 0) pole[k][p] /= animals[jivotno].k;
                }
            }
        }
        animal_jumps = false;
    }
    output_f();
    return 0;
}






